
package eu.dnetlib.oa.graph.usagestatsbuild.export;

import java.io.IOException;
import java.sql.SQLException;
import java.sql.Statement;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Main class for downloading and processing Usage statistics
 *
 * @author D. Pierrakos
 */
public class UsageStatsExporter {

	public UsageStatsExporter() {

	}

	private static final Logger logger = LoggerFactory.getLogger(UsageStatsExporter.class);

	public void export() throws Exception {

		logger.info("Initialising DB properties");
		ConnectDB.init();

		EpisciencesViewsDownloads episciencesViewsDownloads = new EpisciencesViewsDownloads();
		logger.info("Processing Episciences logs");
		episciencesViewsDownloads.processEpisciencesLogs();
		logger.info("Episciences logs Done");
	}
}
